// Tool-specific include files
#include  "iomaxq200x.h"  // MAXQ2000 registers
#include  "intrinsics.h"  // intrinsic functions

int nest_level=0;   // will be nesting level
// Interrupt Service Routines
#pragma vector=0
__interrupt void isr_module0() {
  long i;
  EIF0_bit.IE0=0;           // clear int flag
  nest_level++;             // increment level counter
  SBUF0=nest_level+0x30;    // output nest_level as ASCII
  if(nest_level<7)          // allow up to 7 nested interrupts
    __reenable_interrupt(); // clear INS bit (IC_bit.INS=0;)
  IC_bit.INS=1;
  for(i=0;i<1000000;) i++;  // long pause (burn 10^6 cycles)
  nest_level--;             // decrement level counter
}
// Application Code
int main(int argc, char* argv[]) {
  int i;
  // Init Interrupts
  EIES0_bit.IT0=1;  // configuer negative edge trigger
  EIE0_bit.EX0=1;               // enable ext0 itnterrupt
  __set_interrupt_state(0x01);  // enable modules 0,7 (IMR_bit.IM0=1;)
  __enable_interrupt();         // global enable (IC_bit.IGE=1;)
  // Init UART0 (serial)
  SCON0=0x50;       // async.mode 1, clock/4
  SMD0=0x02;        // clock/16, int disabled
  PR0=0x3AFB;       // 115200 bps @ 16MHz

  while(1) {
    // output nest_level as ASCII
    SBUF0=nest_level+0x30;  // start transmission
    for(i=0;i<5000;) i++;   // pause (burn 5000 cycles)
  }
}
