; Tool-specific Header
  RSEG CODE
  PUBLIC main

; Interrupt Service Routine
isr_timer1_ovfl:
  move  M4[8].3,#0  ; clear interrupt flag
  move  M0[0].0,#1  ; set pin high
  move  M0[0].0,#0  ; set pin low
  move  M2[7],#0x24 ; start transmission
  reti

; Application Code
main:
  ; Init UART0 (serial)
  move  M2[6], #0x50    ; async.mode 1, clock/4
  move  M2[8], #0x02    ; clock/16, int disabled
  move  M2[9], #0x3AFB  ; 115200 bps @ 16MHz

loop:
  ; Very Important Tasks
  nop
  nop
  nop
  ; send a byte over serial port
  move  M2[7],#0x35 ; start transmission
  move  LC[0],#5000 ; load pause count
  djnz  LC[0],$     ; pause (burn 5000 cycles)
  jump  loop

; Tool-specific Footer
  END
