; Tool-specific Header
  RSEG CODE
  PUBLIC main

; Interrupt Service Routine
isr_timer1_ovfl:
  move  M4[8].3,#0  ; clear interrupt flag
  move  M0[0].0,#1  ; set pin high
  move  M0[0].0,#0  ; set pin low
  move  M2[7],#0x24 ; start transmission
  reti
; Application Code
main:
  ; Init Interrupt
  move  M4[10],#(65536-16000) ; ovfl every 1ms @ 16MHz
  move  M4[9],M4[10]          ; init counter
  move  M4[16],#0x0           ; 16-bit timer mode
  move  IV,#w:isr_timer1_ovfl ; load interrupt vector
  move  M4[0],#0x88     ; int enabled, start the timer
  move  IMR.4,#1        ; enable ints from module 4
  move  IC.0,#1         ; enable global interrupts (IGE=1)
  ; Init Port Pin P0.0
  move  M0[16].0,#1     ; Configure P0.0 direction (output)
  move  M0[0].0,#0      ; Set P0.0 Low
  ; Init UART0 (serial)
  move  M2[6], #0x50    ; async.mode 1, clock/4
  move  M2[8], #0x02    ; clock/16, int disabled
  move  M2[9], #0x3AFB  ; 115200 bps @ 16MHz

loop:
  ; Very Important Tasks
  nop
  nop
  nop
  ; send a byte over serial port
  move  M2[7],#0x35 ; start transmission
  move  LC[0],#5000 ; load pause count
  djnz  LC[0],$     ; pause (burn 5000 cycles)
  jump  loop

; Tool-specific Footer
  END
