#include "stdio.h"

// Tool-specific include file
#include  "iomaxq200x.h"  // MAXQ2000 registers


// Interrupt Service Routine
#pragma vector=4
__interrupt void isr_module4() {
  T2CNB1_bit.TF2=0; // clear interrupt flag
  PO0=1;            // set pin high
  PO0=0;            // set pin low
  SBUF0='$';        // start transmission
}

// Application Code
int main(int argc, char* argv[]) {
  int i;
  // Init Interrupt
  T2R1=65536-16000; // ovfl every 1ms @ 16MHz
  T2V1=T2R1;        // init counter
  T2CFG1=0;         // 16-bit timer mode
  T2CNA1=0x88;      // int enabled, start the timer
  IMR_bit.IM4=1;    // enable ints from module 4
  IC_bit.IGE=1;     // enable global interrupts (IGE=1)
  // Init Port Pin P0.0
  PD0=1;            // Configure P0.0 direction (output)
  PO0=0;            // Set P0.0 Low
  // Init UART0 (serial)
  SCON0=0x50;       // async.mode 1, clock/4
  SMD0=0x02;        // clock/16, int disabled
  PR0=0x3AFB;       // 115200 bps @ 16MHz

  while(1) {
    // Very Important Tasks
    i=i;
    // send a byte over serial port
    SBUF0='5';        //start transmission

    for(i=0;i<5000;) i++; // pause (burn 5000 cycles)
  }
}
